package cn.minbb.evaluationsystemserver.controller;

import cn.minbb.evaluationsystemserver.entity.Feedback;
import cn.minbb.evaluationsystemserver.entity.User;
import cn.minbb.evaluationsystemserver.service.FeedbackService;
import cn.minbb.evaluationsystemserver.service.UserService;
import cn.minbb.evaluationsystemserver.util.ResponseMap;
import cn.minbb.evaluationsystemserver.util.Result;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("/feedback")
public class FeedbackController {

    private final FeedbackService feedbackService;
    private final UserService userService;

    @Autowired
    public FeedbackController(FeedbackService feedbackService, UserService userService) {
        this.feedbackService = feedbackService;
        this.userService = userService;
    }

    @PostMapping(value = "", produces = "text/plain; charset=UTF-8")
    @ResponseBody
    public String feedback(@RequestParam(value = "feedback") String feedbackJSON, @RequestParam(value = "user") String userJSON) {
        ResponseMap responseMap = new ResponseMap();
        if (!feedbackJSON.isEmpty() && !userJSON.isEmpty()) {
            try {
                Feedback feedback = JSONObject.parseObject(feedbackJSON, Feedback.class);
                User userClient = JSONObject.parseObject(userJSON, User.class);
                User userServer = userService.findUserByUsername(userClient.getUsername());
                if (userServer != null && userServer.getPassword().equals(userClient.getPassword())) {
                    feedback.setUser(userServer);
                    feedbackService.save(feedback);
                    responseMap.putResult(Result.SUCCESS);
                    responseMap.putSummary("反馈成功，非常感谢您的关注！");
                } else {
                    feedback.setUser(null);
                    feedbackService.save(feedback);
                    responseMap.putResult(Result.SUCCESS);
                    responseMap.putSummary("反馈成功，非常感谢您的关注！");
                }
            } catch (Exception e) {
                e.printStackTrace();
                responseMap.putResult(Result.FAILED);
                responseMap.putSummary("反馈信息和用户身份信息格式有误");
            }
        } else {
            responseMap.putResult(Result.FAILED);
            responseMap.putSummary("反馈信息和用户身份信息不能为空");
        }
        return JSONObject.toJSONString(responseMap.getMap());
    }
}
