package cn.minbb.evaluationsystemserver.controller;

import cn.minbb.evaluationsystemserver.entity.Classification;
import cn.minbb.evaluationsystemserver.service.ClassificationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import java.util.List;

@Controller
@RequestMapping("")
public class MainController {

    private ClassificationService classificationService;

    @Autowired
    public MainController(ClassificationService classificationService) {
        this.classificationService = classificationService;
    }

    @GetMapping(value = "/")
    public String indexPage() {
        return "index";
    }

    @GetMapping(value = "/register")
    public String registerPage() {
        return "register";
    }

    @GetMapping(value = "/login")
    public String loginPage() {
        return "login";
    }

    @GetMapping(value = "/question")
    public String problemPage(ModelMap map) {
        List<Classification> classificationList = classificationService.findEnabledClassification();
        map.addAttribute("classificationList", classificationList);
        return "question";
    }
}
