package cn.minbb.evaluationsystemserver.controller;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class WebFileConfiguration implements WebMvcConfigurer {

    @Override
    public void addResourceHandlers(ResourceHandlerRegistry registry) {
        // 和页面有关的静态目录都放在项目的 static 目录下
        registry.addResourceHandler("/static/**").addResourceLocations("classpath:/static/");
        // 上传的图片在 C 盘下的 Evaluation 目录下，访问路径如：http://localhost:80/user/***/123.jpg
        // 其中 user 表示访问的前缀。"file:C:/Evaluation/"是文件真实的存储路径
        registry.addResourceHandler("/user/**").addResourceLocations("file:C:/Evaluation/");
    }
}
