package cn.minbb.evaluationsystemserver.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import javax.persistence.Version;
import java.util.Date;

@Entity
@Table(name = "answer")
@NoArgsConstructor
public class Answer {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "e_id", nullable = false, columnDefinition = "BIGINT COMMENT '答案实体ID'")
    private Long e_id;

    @Getter
    @Setter
    @Column(name = "content", nullable = false, columnDefinition = "VARCHAR(255) COMMENT '答案内容'")
    private String content;

    @Getter
    @Setter
    @Column(name = "score", nullable = false, columnDefinition = "FLOAT DEFAULT 0 COMMENT '答案分数'")
    private Float score;

    @Getter
    @Setter
    @ManyToOne(cascade = {CascadeType.REFRESH}, optional = false)
    @JoinColumn(name = "question_id", columnDefinition = "BIGINT COMMENT '题目实体ID'")
    private Question question;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    @Getter
    @Setter
    @Column(name = "updated_at", columnDefinition = "DATETIME COMMENT '更新时间'")
    @UpdateTimestamp
    private Date updatedAt;

    @Version
    @Column(name = "version", columnDefinition = "BIGINT COMMENT '版本号'")
    public Long version;
}
