package cn.minbb.evaluationsystemserver.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import javax.persistence.Version;
import java.util.Date;

@Entity
@Table(name = "feedback")
@NoArgsConstructor
public class Feedback {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "e_id", nullable = false, columnDefinition = "BIGINT COMMENT '反馈实体ID'")
    private Long e_id;

    @Getter
    @Setter
    @Column(name = "type", columnDefinition = "VARCHAR(32) COMMENT '反馈类型'")
    private String type;

    @Getter
    @Setter
    @Column(name = "title", columnDefinition = "VARCHAR(128) COMMENT '反馈标题'")
    private String title;

    @Getter
    @Setter
    @Column(name = "content", columnDefinition = "VARCHAR(255) COMMENT '反馈内容'")
    private String content;

    @Getter
    @Setter
    @Column(name = "name", columnDefinition = "VARCHAR(16) COMMENT '联系人'")
    private String name;

    @Getter
    @Setter
    @Column(name = "contact", columnDefinition = "VARCHAR(32) COMMENT '联系方式'")
    private String contact;

    @Getter
    @Setter
    @Column(name = "reply", columnDefinition = "VARCHAR(255) COMMENT '反馈回复'")
    private String reply;

    @Getter
    @Setter
    @ManyToOne(cascade = {CascadeType.MERGE, CascadeType.REFRESH}, optional = true)
    @JoinColumn(name = "user_id", columnDefinition = "BIGINT COMMENT '用户实体ID'")
    private User user;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    @Getter
    @Setter
    @Column(name = "updated_at", columnDefinition = "DATETIME COMMENT '更新时间'")
    @UpdateTimestamp
    private Date updatedAt;

    @Version
    @Column(name = "version", columnDefinition = "BIGINT COMMENT '版本号'")
    public Long version;
}
