package cn.minbb.evaluationsystemserver.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "logs")
@NoArgsConstructor
public class Logs {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "e_id", nullable = false, columnDefinition = "BIGINT COMMENT '日志实体ID'")
    private Long e_id;

    @Getter
    @Setter
    @Column(name = "action", nullable = false, columnDefinition = "VARCHAR(64) COMMENT '产生的动作'")
    private String action;

    @Getter
    @Setter
    @Column(name = "data", nullable = false, columnDefinition = "VARCHAR(64) COMMENT '产生的数据'")
    private String data;

    @Getter
    @Setter
    @ManyToOne(cascade = {CascadeType.MERGE, CascadeType.REFRESH}, optional = true)
    @JoinColumn(name = "user_id", columnDefinition = "BIGINT COMMENT '发起用户实体ID'")
    private User user;

    @Getter
    @Setter
    @Column(name = "ip", nullable = false, columnDefinition = "VARCHAR(64) COMMENT '日志产生的IP'")
    private String ip;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    public Logs(String action, String data, User user, String ip) {
        this.action = action;
        this.data = data;
        this.user = user;
        this.ip = ip;
    }
}