package cn.minbb.evaluationsystemserver.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import javax.persistence.Version;
import java.util.Date;
import java.util.List;

@Entity
@Table(name = "reply")
@NoArgsConstructor
public class Reply {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "e_id", nullable = false, columnDefinition = "BIGINT COMMENT '回应实体ID'")
    private Long e_id;

    @Getter
    @Setter
    @Column(name = "more_than", nullable = false, columnDefinition = "FLOAT DEFAULT 0 COMMENT '大于等于'")
    private Float moreThan;

    @Getter
    @Setter
    @ManyToOne(cascade = {CascadeType.REFRESH}, optional = false)
    @JoinColumn(name = "classification_id", columnDefinition = "BIGINT COMMENT '题目类别'")
    private Classification classification;

    @Getter
    @Setter
    @OneToMany(cascade = {CascadeType.REFRESH}, mappedBy = "reply", fetch = FetchType.LAZY)
    // 试卷（集合）
    private List<Paper> paperList;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    @Getter
    @Setter
    @Column(name = "updated_at", columnDefinition = "DATETIME COMMENT '更新时间'")
    @UpdateTimestamp
    private Date updatedAt;

    @Version
    @Column(name = "version", columnDefinition = "BIGINT COMMENT '版本号'")
    public Long version;
}
