package cn.minbb.evaluationsystemserver.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "version")
@NoArgsConstructor
public class Version {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "e_id", nullable = false, columnDefinition = "BIGINT COMMENT '版本实体ID'")
    private Long e_id;

    @Getter
    @Setter
    @Column(name = "version_code", nullable = false, length = 11, columnDefinition = "INT COMMENT '版本号'")
    private Integer versionCode;

    @Getter
    @Setter
    @Column(name = "version_name", nullable = false, length = 64, columnDefinition = "VARCHAR(64) COMMENT '版本名'")
    private String versionName;

    @Getter
    @Setter
    @Column(name = "file_name", nullable = false, columnDefinition = "VARCHAR(64) COMMENT '文件名'")
    private String fileName;

    @Getter
    @Setter
    @Column(name = "content", columnDefinition = "VARCHAR(255) COMMENT '更新内容/日志'")
    private String content;

    @Getter
    @Setter
    @Column(name = "file_size", length = 11, columnDefinition = "INT COMMENT '新文件大小（字节）'")
    private Integer fileSize;

    @Getter
    @Setter
    @Column(name = "file_url", nullable = false, columnDefinition = "VARCHAR(255) COMMENT '新文件下载地址'")
    private String fileUrl;

    @Getter
    @Setter
    @Column(name = "forced", columnDefinition = "BIT COMMENT '强制更新'")
    private Boolean forced;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    @Getter
    @Setter
    @Column(name = "updated_at", columnDefinition = "DATETIME COMMENT '更新时间'")
    @UpdateTimestamp
    private Date updatedAt;

    @javax.persistence.Version
    @Column(name = "version", columnDefinition = "BIGINT COMMENT '版本号'")
    public Long version;

    public Version(String fileName) {
        this.fileName = fileName;
    }
}
