package cn.minbb.evaluationsystemserver.service.impl;

import cn.minbb.evaluationsystemserver.entity.Paper;
import cn.minbb.evaluationsystemserver.entity.User;
import cn.minbb.evaluationsystemserver.entity.repository.PaperRepository;
import cn.minbb.evaluationsystemserver.service.PaperService;
import cn.minbb.evaluationsystemserver.util.App;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class PaperServiceImpl implements PaperService {

    private PaperRepository paperRepository;

    @Autowired
    public PaperServiceImpl(PaperRepository paperRepository) {
        this.paperRepository = paperRepository;
    }

    @Override
    public Paper save(Paper paper) {
        paper.setStartedAt(App.getCurrentDateTime());
        return paperRepository.save(paper);
    }

    @Override
    public Paper findPaperByE_Id(Long e_id) {
        return paperRepository.getOne(e_id);
    }

    @Override
    public Paper submit(Paper paperServer, Float mark) {
        Paper paper = paperRepository.getOne(paperServer.getE_id());
        paper.setMark(mark);
        paper.setEndedAt(App.getCurrentDateTime());
        return paperRepository.save(paper);
    }

    @Override
    public List<Paper> findHistoryPapers(User user, int page, int size) {
        return paperRepository.findPapersByUser(user, PageRequest.of(page, size, new Sort(Sort.Direction.ASC, "createdAt")));
    }
}
