package cn.minbb.evaluationsystemserver.service.impl;

import cn.minbb.evaluationsystemserver.entity.Classification;
import cn.minbb.evaluationsystemserver.entity.Question;
import cn.minbb.evaluationsystemserver.entity.repository.QuestionRepository;
import cn.minbb.evaluationsystemserver.service.QuestionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class QuestionServiceImpl implements QuestionService {

    private QuestionRepository questionRepository;

    @Autowired
    public QuestionServiceImpl(QuestionRepository questionRepository) {
        this.questionRepository = questionRepository;
    }

    @Override
    public List<Question> randomSelection(List<Classification> classificationList, int count) {
        List<Question> questionListLibrary = questionRepository.findByEnabledTrueAndClassificationList(classificationList);
        List<Question> questionList = new ArrayList<>(count);
        int librarySize = questionListLibrary.size();
        if (librarySize <= count) {
            // 题库题目数量不够随机抽取
            questionList = questionListLibrary;
        } else {
            for (int i = 0; i < count; i++) {
                questionList.add(questionListLibrary.remove(new Random().nextInt(questionListLibrary.size())));
            }
        }
        return questionList;
    }
}
