package cn.minbb.evaluationsystemserver.service.impl;

import cn.minbb.evaluationsystemserver.entity.Version;
import cn.minbb.evaluationsystemserver.entity.repository.VersionRepository;
import cn.minbb.evaluationsystemserver.service.VersionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class VersionServiceImpl implements VersionService {

    private VersionRepository versionRepository;

    @Autowired
    public VersionServiceImpl(VersionRepository versionRepository) {
        this.versionRepository = versionRepository;
    }

    @Override
    public Version getLatestVersion() {
        // 按照 code 降序查询全部，取第一条数据
        // return versionRepository.findAll(new Sort(Sort.Direction.DESC, "code")).get(0);
        // 按照 code 降序，查第一个
        return versionRepository.findTopByOrderByVersionCodeDesc();
    }

    @Override
    public Version findVersionByVersionCode(Integer versionCode) {
        return versionRepository.findVersionByVersionCode(versionCode);
    }
}
